# Instance As Identity: A Generic Online Paradigm for Video Instance Segmentation

## Introduction

This repo is the evaluation code of IAI + CondInst model for video instance segmentation, and we will release training code later. The overview of IAI paradigm is shown below.

<img src='doc/IAI_framework.png'>

## Prepare Environment

This repo is built on MMDetection-2.11, and it requires Python3 and PyTorch >= 1.5. This repo also relies on MMCV-1.3.8 & mmpycocotools-VIS-version, and you could install them by using following commands.

```
pip install mmpycocotools
put pycocotools/ytvos.py & pycocotools/ytvos_eval.py under your local installed pycocotools directory

pip install mmcv-full==1.3.8 -f https://download.openmmlab.com/mmcv/dist/{cu_version}/{torch_version}/index.html
```

When installing mmcv, you can set [cu_version} to cu92 or other version, {torch_version} to 1.5.0 or other version.
For example, if your environment is cuda 9.2 & torch 1.5.0, use

```
pip install mmcv-full==1.3.8 -f https://download.openmmlab.com/mmcv/dist/cu92/1.5.0/index.html
```

## Prepare YouTubeVIS 2019 Dataset

1. Download YouTubeVIS 2019 from YouTube VIS challenge.
2. Symlink the train/validation dataset to `data` folder. Put COCO-style annotations under `data/annotations`.

```
IAI
├── mmdet
├── tools
├── configs
├── data
│   ├── train
│   ├── val
│   ├── annotations
│   │   ├── instances_train_sub.json
│   │   ├── instances_val_sub.json
```

## Prepare OVIS Dataset

1. Download OVIS from OVIS challenge.
2. Symlink the train/validation dataset to `data` folder. Put COCO-style annotations under `data/annotations`.

```
IAI
├── mmdet
├── tools
├── configs
├── data
│   ├── train
│   ├── val
│   ├── annotations
│   │   ├── annotations_train.json
│   │   ├── annotations_valid.json
```

## Evaluation

The results are listed as below, and you can download coresponding pretrained models. Put the pretrained models under models directory, and run `sh *_run.sh`

### YouTube-VIS 2019

Model | mAP | Download
------ | ------|----------
IAI_CondInst_r50 | [37.9](results/ytvis2019_r50.txt) | [google](https://drive.google.com/file/d/1XkV7y6yH8hzTvdJHFk8GK3DKoPBGKFZz/view?usp=sharing)
IAI_CondInst_r101 | [41.9](results/ytvis2019_r101.txt) | [google](https://drive.google.com/file/d/1n02dvAete0Iiw94pzV-KuKgSCwHaJDXG/view?usp=sharing)

### OVIS

Model | mAP | Download
------ | ------|----------
IAI_CondInst_r50      | [20.3](results/ovis_r50.txt)     | [google](https://drive.google.com/file/d/1TJNViNMh67H1mHmkhG9Mrs5LEE2X-EF2/view?usp=sharing)

A json file with the predicted result will be generated as ```output/results.json```. These three benmarks currently only allows evaluation on the codalab server. Please compress the json file and upload the generated zip file to corresponding codalab server to see performance.